VTK: vtkRenderTimerLog Class Reference

| VTK 9.3.1

Classes | Public Types | Public Member Functions | Static Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
vtkRenderTimerLog Class Reference

Asynchronously measures GPU execution times for a series of events. More...

`#include <vtkRenderTimerLog.h>`

Inheritance diagram for vtkRenderTimerLog:
[legend]
Collaboration diagram for vtkRenderTimerLog:
[legend]

## Classes
struct | Event
| Container for a single timed event. More...
struct | Frame
| Container for a frame's events. More...
struct | ScopedEventLogger
| RAII struct for logging events. More...

## Public Types
typedef vtkObject | Superclass

## Public Member Functions
virtual vtkTypeBool | IsA (const char *type)
| Return 1 if this class is the same type of (or a subclass of) the named class. More...
vtkRenderTimerLog * | NewInstance () const
void | PrintSelf (ostream &os, vtkIndent indent) override
| Methods invoked by print to print information about the object including superclasses. More...
virtual bool | IsSupported () VTK_FUTURE_CONST
| Returns true if stream timings are implemented for the current graphics backend. More...
virtual void | MarkFrame ()
| Call to mark the start of a new frame, or the end of an old one. More...
ScopedEventLogger | StartScopedEvent (const std::string &name)
| Create a RAII scoped event. More...
virtual bool | FrameReady ()
| Returns true if there are any frames ready with complete timing info. More...
virtual Frame | PopFirstReadyFrame ()
| Retrieve the first available frame's timing info. More...
virtual void | ReleaseGraphicsResources ()
| Releases any resources allocated on the graphics device. More...
virtual void | MarkStartEvent (const std::string &name)
| Mark the beginning or end of an event. More...
virtual void | MarkEndEvent ()
| Mark the beginning or end of an event. More...
virtual void | SetLoggingEnabled (bool)
| If false, no events are recorded. More...
virtual bool | GetLoggingEnabled ()
| If false, no events are recorded. More...
virtual void | LoggingEnabledOn ()
| If false, no events are recorded. More...
virtual void | LoggingEnabledOff ()
| If false, no events are recorded. More...
virtual void | SetFrameLimit (unsigned int)
| If there are more than FrameLimit frames pending/ready, drop the old ones until we are under this limit. More...
virtual unsigned int | GetFrameLimit ()
| If there are more than FrameLimit frames pending/ready, drop the old ones until we are under this limit. More...
Public Member Functions inherited from vtkObject
| vtkBaseTypeMacro (vtkObject, vtkObjectBase)
virtual void | DebugOn ()
| Turn debugging output on. More...
virtual void | DebugOff ()
| Turn debugging output off. More...
bool | GetDebug ()
| Get the value of the debug flag. More...
void | SetDebug (bool debugFlag)
| Set the value of the debug flag. More...
virtual void | Modified ()
| Update the modification time for this object. More...
virtual vtkMTimeType | GetMTime ()
| Return this object's modified time. More...
void | RemoveObserver (unsigned long tag)
void | RemoveObservers (unsigned long event)
void | RemoveObservers (const char *event)
void | RemoveAllObservers ()
vtkTypeBool | HasObserver (unsigned long event)
vtkTypeBool | HasObserver (const char *event)
vtkTypeBool | InvokeEvent (unsigned long event)
vtkTypeBool | InvokeEvent (const char *event)
std::string | GetObjectDescription () const override
| The object description printed in messages and PrintSelf output. More...
unsigned long | AddObserver (unsigned long event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
unsigned long | AddObserver (const char *event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkCommand * | GetCommand (unsigned long tag)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObserver (vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, bool(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Allow user to set the AbortFlagOn() with the return value of the callback method. More...
vtkTypeBool | InvokeEvent (unsigned long event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
vtkTypeBool | InvokeEvent (const char *event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
virtual void | SetObjectName (const std::string &objectName)
| Set/get the name of this object for reporting purposes. More...
virtual std::string | GetObjectName () const
| Set/get the name of this object for reporting purposes. More...
Public Member Functions inherited from vtkObjectBase
const char * | GetClassName () const
| Return the class name as a string. More...
virtual vtkIdType | GetNumberOfGenerationsFromBase (const char *name)
| Given the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
virtual void | Delete ()
| Delete a VTK object. More...
virtual void | FastDelete ()
| Delete a reference to this object. More...
void | InitializeObjectBase ()
void | Print (ostream &os)
| Print an object to an ostream. More...
virtual void | Register (vtkObjectBase *o)
| Increase the reference count (mark as used by another object). More...
virtual void | UnRegister (vtkObjectBase *o)
| Decrease the reference count (release by another object). More...
int | GetReferenceCount ()
| Return the current reference count of this object. More...
void | SetReferenceCount (int)
| Sets the reference count. More...
bool | GetIsInMemkind () const
| A local state flag that remembers whether this object lives in the normal or extended memory space. More...
virtual void | PrintHeader (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual void | PrintTrailer (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual bool | UsesGarbageCollector () const
| Indicate whether the class uses `vtkGarbageCollector` or not. More...

## Static Public Member Functions
static vtkRenderTimerLog * | New ()
static vtkTypeBool | IsTypeOf (const char *type)
static vtkRenderTimerLog * | SafeDownCast (vtkObjectBase *o)
Static Public Member Functions inherited from vtkObject
static vtkObject * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | BreakOnError ()
| This method is called when vtkErrorMacro executes. More...
static void | SetGlobalWarningDisplay (vtkTypeBool val)
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOn ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOff ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static vtkTypeBool | GetGlobalWarningDisplay ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
Static Public Member Functions inherited from vtkObjectBase
static vtkTypeBool | IsTypeOf (const char *name)
| Return 1 if this class type is the same type of (or a subclass of) the named class. More...
static vtkIdType | GetNumberOfGenerationsFromBaseType (const char *name)
| Given a the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
static vtkObjectBase * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | SetMemkindDirectory (const char *directoryname)
| The name of a directory, ideally mounted -o dax, to memory map an extended memory space within. More...
static bool | GetUsingMemkind ()
| A global state flag that controls whether vtkObjects are constructed in the usual way (the default) or within the extended memory space. More...

## Protected Member Functions
virtual vtkObjectBase * | NewInstanceInternal () const
| vtkRenderTimerLog ()
| ~vtkRenderTimerLog () override
Protected Member Functions inherited from vtkObject
| vtkObject ()
| ~vtkObject () override
void | RegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | UnRegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | InternalGrabFocus (vtkCommand *mouseEvents, vtkCommand *keypressEvents=nullptr)
| These methods allow a command to exclusively grab all events. More...
void | InternalReleaseFocus ()
| These methods allow a command to exclusively grab all events. More...
Protected Member Functions inherited from vtkObjectBase
| vtkObjectBase ()
virtual | ~vtkObjectBase ()
virtual void | ReportReferences (vtkGarbageCollector *)
| vtkObjectBase (const vtkObjectBase &)
void | operator= (const vtkObjectBase &)

## Protected Attributes
bool | LoggingEnabled
unsigned int | FrameLimit
Protected Attributes inherited from vtkObject
bool | Debug
vtkTimeStamp | MTime
vtkSubjectHelper * | SubjectHelper
std::string | ObjectName
Protected Attributes inherited from vtkObjectBase
std::atomic< int32_t > | ReferenceCount
vtkWeakPointerBase ** | WeakPointers

## Additional Inherited Members
Static Protected Member Functions inherited from vtkObjectBase
static vtkMallocingFunction | GetCurrentMallocFunction ()
static vtkReallocingFunction | GetCurrentReallocFunction ()
static vtkFreeingFunction | GetCurrentFreeFunction ()
static vtkFreeingFunction | GetAlternateFreeFunction ()

## Detailed Description

Asynchronously measures GPU execution times for a series of events.

This class measures the time it takes for events to occur on the GPU by posting timing events into the rendering command stream. This can be used to compute the time spent doing work on the GPU without stalling the CPU.

To aid asynchronous usage, this class uses the concepts "Event" and "Frame", where a Frame is a logical collection of Events. The timer log can manage multiple Frames at a time:

- The current Frame, where new Events are created.
- Pending Frames, for which all Events have been marked, but the results are not available (the timer requests are still waiting to be processed by the graphics device).
- Ready Frames, which have been completed by the graphics device and may be retrieved.

Call MarkFrame() to begin a new Frame. This pushes the current Frame to the collection of pending Frames, and creates a new one to store future Events.

Call MarkStartEvent() and MarkEndEvent() to mark the beginning and end of an Event. These Events may be nested, but all child Events must have their end marked before the parent Event ends.

Use FrameReady() and PopFirstReadyFrame() to check for completed Frames and retrieve results.

This is currently only implemented for the OpenGL2 backend. The IsSupported() method can be used to detect if there is a valid implementation available.

Tests:
  vtkRenderTimerLog (Tests)

Definition at line 72 of file vtkRenderTimerLog.h.

## Member Typedef Documentation

## ◆ Superclass

typedef vtkObject vtkRenderTimerLog::Superclass

Definition at line 154 of file vtkRenderTimerLog.h.

## Constructor & Destructor Documentation

## ◆ vtkRenderTimerLog()

vtkRenderTimerLog::vtkRenderTimerLog | ( |  | ) |
| protected

## ◆ ~vtkRenderTimerLog()

vtkRenderTimerLog::~vtkRenderTimerLog | ( |  | ) |
| overrideprotected

## Member Function Documentation

## ◆ New()

static vtkRenderTimerLog* vtkRenderTimerLog::New | ( |  | ) |
| static

## ◆ IsTypeOf()

static vtkTypeBool vtkRenderTimerLog::IsTypeOf | ( | const char * | type | ) |
| static

## ◆ IsA()

virtual vtkTypeBool vtkRenderTimerLog::IsA | ( | const char * | name | ) |
| virtual

Return 1 if this class is the same type of (or a subclass of) the named class.

Returns 0 otherwise. This method works in combination with vtkTypeMacro found in vtkSetGet.h.

Reimplemented from vtkObjectBase.

Reimplemented in vtkOpenGLRenderTimerLog.

## ◆ SafeDownCast()

static vtkRenderTimerLog* vtkRenderTimerLog::SafeDownCast | ( | vtkObjectBase * | o | ) |
| static

## ◆ NewInstanceInternal()

virtual vtkObjectBase* vtkRenderTimerLog::NewInstanceInternal | ( |  | ) | const
| protectedvirtual

Reimplemented in vtkOpenGLRenderTimerLog.

## ◆ NewInstance()

vtkRenderTimerLog* vtkRenderTimerLog::NewInstance | ( |  | ) | const

## ◆ PrintSelf()

void vtkRenderTimerLog::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) |  |
| overridevirtual

Methods invoked by print to print information about the object including superclasses.

Typically not called by the user (use Print() instead) but used in the hierarchical print process to combine the output of several classes.

Reimplemented from vtkObject.

Reimplemented in vtkOpenGLRenderTimerLog.

## ◆ IsSupported()

virtual bool vtkRenderTimerLog::IsSupported | ( |  | ) |
| virtual

Returns true if stream timings are implemented for the current graphics backend.

Reimplemented in vtkOpenGLRenderTimerLog.

## ◆ MarkFrame()

virtual void vtkRenderTimerLog::MarkFrame | ( |  | ) |
| virtual

Call to mark the start of a new frame, or the end of an old one.

Does nothing if no events have been recorded in the current frame.

Reimplemented in vtkOpenGLRenderTimerLog.

## ◆ StartScopedEvent()

ScopedEventLogger vtkRenderTimerLog::StartScopedEvent | ( | const std::string & | name | ) |

Create a RAII scoped event.

See ScopedEventLogger for details.

## ◆ MarkStartEvent()

virtual void vtkRenderTimerLog::MarkStartEvent | ( | const std::string & | name | ) |
| virtual

Mark the beginning or end of an event.

Reimplemented in vtkOpenGLRenderTimerLog.

## ◆ MarkEndEvent()

virtual void vtkRenderTimerLog::MarkEndEvent | ( |  | ) |
| virtual

Mark the beginning or end of an event.

Reimplemented in vtkOpenGLRenderTimerLog.

## ◆ FrameReady()

virtual bool vtkRenderTimerLog::FrameReady | ( |  | ) |
| virtual

Returns true if there are any frames ready with complete timing info.

Reimplemented in vtkOpenGLRenderTimerLog.

## ◆ PopFirstReadyFrame()

virtual Frame vtkRenderTimerLog::PopFirstReadyFrame | ( |  | ) |
| virtual

Retrieve the first available frame's timing info.

The returned frame is removed from this log.

Reimplemented in vtkOpenGLRenderTimerLog.

## ◆ SetLoggingEnabled()

virtual void vtkRenderTimerLog::SetLoggingEnabled | ( | bool |  | ) |
| virtual

If false, no events are recorded.

Default is false.

## ◆ GetLoggingEnabled()

virtual bool vtkRenderTimerLog::GetLoggingEnabled | ( |  | ) |
| virtual

If false, no events are recorded.

Default is false.

Reimplemented in vtkOpenGLRenderTimerLog.

## ◆ LoggingEnabledOn()

virtual void vtkRenderTimerLog::LoggingEnabledOn | ( |  | ) |
| virtual

If false, no events are recorded.

Default is false.

## ◆ LoggingEnabledOff()

virtual void vtkRenderTimerLog::LoggingEnabledOff | ( |  | ) |
| virtual

If false, no events are recorded.

Default is false.

## ◆ SetFrameLimit()

virtual void vtkRenderTimerLog::SetFrameLimit | ( | unsigned int |  | ) |
| virtual

If there are more than FrameLimit frames pending/ready, drop the old ones until we are under this limit.

Prevents things from backing up. Default is 32. Set to 0 to disable.

## ◆ GetFrameLimit()

virtual unsigned int vtkRenderTimerLog::GetFrameLimit | ( |  | ) |
| virtual

If there are more than FrameLimit frames pending/ready, drop the old ones until we are under this limit.

Prevents things from backing up. Default is 32. Set to 0 to disable.

## ◆ ReleaseGraphicsResources()

virtual void vtkRenderTimerLog::ReleaseGraphicsResources | ( |  | ) |
| virtual

Releases any resources allocated on the graphics device.

Reimplemented in vtkOpenGLRenderTimerLog.

## Member Data Documentation

## ◆ LoggingEnabled

bool vtkRenderTimerLog::LoggingEnabled
| mutableprotected

Definition at line 216 of file vtkRenderTimerLog.h.

## ◆ FrameLimit

unsigned int vtkRenderTimerLog::FrameLimit
| protected

Definition at line 217 of file vtkRenderTimerLog.h.

The documentation for this class was generated from the following file:

- Rendering/Core/vtkRenderTimerLog.h